Read excludes from /backup directory
[wizbackup.git] / wizbackup
index ad7a549ce2c099fadc0998e3f6e43fc489d163dd..816a66b82ff3641eaa40a41f3ebceb4ba97ca33c 100755 (executable)
--- a/wizbackup
+++ b/wizbackup
@@ -1,33 +1,41 @@
 #!/bin/bash
 #
-# wizbackup 2.0 - Simple rsync backup
+# WizBackup 2.0 - Simple rsync backup
 # Based on incremental-backup 0.1 by Matteo Mattei
 #
 # Copyright 2006 Matteo Mattei <matteo.mattei@gmail.com>
 # Copyright 2007, 2008, 2009, 2010, 2011 Bernie Innocenti <bernie@codewiz.org>
 #
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License,
-# or (at your option) any later version.
-
+#  This program is free software: you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation, either version 3 of the License,
+#  or (at your option) any later version.
+#
+#  This program is distributed in the hope that it will be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
+#
+#  You should have received a copy of the GNU General Public License
+#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
 
 if [ $# -lt 2 ]; then
        echo "Usage: $0 SOURCE DEST [RSYNC_OPTS]"
        exit 1
 fi
 
-# Fail on any error; Treat undefined variables as errors
-set -e -u
+# Treat undefined variables as errors
+set -u
 
 #####################################################################
 # CONFIGURATION
 #####################################################################
 
-# Source path
+# Source rsync URL
 SRC=$1; shift
 
-# DESTINATION DIRECTORY (must exists)
+# Destination directory (will be created if it doesn't exist)
 DEST=$1; shift
 
 # NOTE: --timeout needs to be large enough: if a large dir tree don't change a lot of time can pass without I/O
@@ -37,6 +45,9 @@ RSYNC_OPTS="-HAXa --stats --timeout 1800 --numeric-ids --delete --delete-exclude
 # Number of saved snapshots
 SNAPSHOTS=45
 
+# Abort backup if the destination volume has less than these GBs free
+MIN_FREE_GB=10
+
 RESULT=500
 DATE=`date +"%Y%m%d"`
 DEST="`echo $DEST | sed -e 's/\/$//'`"
@@ -116,12 +127,29 @@ do_link()
                echo "$(date): Linking snapshot $DEST/$newest to $DEST/tmp"
                # TODO: Creating the hardlinks takes a lot of time.
                # Perhaps we could save time by recycling the oldest snapshot
-               cp -lR "$DEST/$newest" "$DEST/tmp" || exit 670
+               cp -la "$DEST/$newest" "$DEST/tmp"
+               RESULT=$?
+               if [ $RESULT -ne 0 ]; then
+                       echo "$(date): Failed to setup tmp snapshot: $RESULT. Cleaning up."
+                       rm -rf "$DEST/tmp"
+                       exit $RESULT
+               fi
        fi
 }
 
 do_test()
 {
+       # TODO: test for free space and free inodes in the $DEST filesystem
+       block_size=`stat --file-system --format "%S" "$DEST"`
+       free_blocks=`stat --file-system --format "%f" "$DEST"`
+       free_inodes=`stat --file-system --format "%d" "$DEST"`
+       free_gb=$((block_size * free_blocks / 1024 / 1024 / 1024))
+
+       if [ "$free_gb" -lt "$MIN_FREE_GB" ]; then
+               echo "$(date): Aborting due to insufficient free space ${free_gb}GB."
+               exit 670
+       fi
+
        # Avoid clobbering the latest snapshot if the remote host does
        # not allow us to connect
        # --contimeout: sometimes hangs on connection...
@@ -133,9 +161,9 @@ do_test()
        fi
 }
 
-######################
-# MAIN
-######################
+######################################
+# Main
+######################################
 
 # make sure to be root
 if (( `id -u` != 0 )); then { echo "Sorry, must be root.  Exiting..."; exit; } fi